diff --git a/src/bin/pg_upgrade/info.c b/src/bin/pg_upgrade/info.c
index 7f21d26fd2..21a0b0551a 100644
--- a/src/bin/pg_upgrade/info.c
+++ b/src/bin/pg_upgrade/info.c
@@ -297,6 +297,11 @@ get_db_rel_and_slot_infos(ClusterInfo *cluster, bool live_check)
 		 */
 		if (cluster == &old_cluster)
 			get_old_cluster_logical_slot_infos(pDbInfo, live_check);
+		else
+		{
+			pDbInfo->slot_arr.slots = NULL;
+			pDbInfo->slot_arr.nslots = 0;
+		}
 	}
 
 	if (cluster == &old_cluster)
